<template>
  <div class="info-box">
    <div v-if="time">
      Current Time: {{ time.toFixed(2) }}
    </div>
    <div>Current Musical Time {{ computeMusicalTime }}</div>
    <div>Cursor X {{ cursorPosition.x .toFixed(0) }} Y {{ cursorPosition.y.toFixed(0) }}</div>
    <hr>
    <div v-if="selectedLabel">
      <v-expansion-panels v-model="expansionPanels" multiple>
        <v-expansion-panel style="border: none; background-color: transparent; color: white;">
          <v-expansion-panel-header style="padding: 5px">
            Selected Label
          </v-expansion-panel-header>
          <v-expansion-panel-content class="selectedLabelWrapper">
            <div
              v-for="(key, index) in Object.keys(selectedLabel)"
              :key="index"
              class="selectedLabel"
            >
              <span>{{ key }}</span><span>{{ selectedLabel[key] }}</span>
            </div>
          </v-expansion-panel-content>
        </v-expansion-panel>
      </v-expansion-panels>
    </div>
  </div>
</template>

<script lang="ts">
import type {
  Label,
  Onset, Second, Signature, Unit,
} from '@/data';
import { Component, Prop, Vue } from 'vue-property-decorator';
import type { Position } from 'vue-router/types/router';

@Component({})
export default class InfoBox extends Vue {
  @Prop()
  time!: Second;

  @Prop()
  musicalTime!: Onset;

  @Prop({ required: true })
  cursorPosition!: Position;

  @Prop({ required: true })
  signature!: Signature;

  @Prop({ required: false })
  secondUnit!: Unit<Second> | null;

  @Prop({ required: false, default: null })
  selectedLabel!: Label;

  expansionPanels = [0];

  get computeMusicalTime(): string {
    const repeat = this.secondUnit?.toOnset(this.time);
    return `${this.signature.printOnset(this.musicalTime, true)} | ${repeat?.repeat}`;
  }
}
</script>

<style lang="scss" scoped>
.info-box {
  position:absolute;
  z-index: 1000;
  padding: 10px;
  top: 10px;
  left: 10px;
  background: #00000099;
  width: auto;
  height: auto;
  color: white;
  font-size: 12px;

  & .selectedLabel {
    &:nth-child(odd) {
      background-color: #00000055;
    }
    display: flex;
    padding: 2px 5px;
    justify-content: space-between;
    background-color: #33333355;
  }
}

::v-deep {
  & .v-expansion-panel-content__wrap {
    padding: 0;
  }
  & .v-expansion-panel::before {
    box-shadow: none;
    transition: none;
  }
  & .mdi-chevron-down::before {
    color: white;
  }
}
</style>
